/****************************************************
JavaRa (javara.cpp) (c) Paul McLain and Fred de Vries, 2008, 2009, 2.
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
************************************************************/
#include <windows.h>
#include <stdio.h>
#include <shlwapi.h>
#include "javara.h"
#include <time.h>
#include <tlhelp32.h>
#include <winreg.h>
#include "hyperlinks.cpp"
#include "hyperlinks.h"
#include "killprocess.cpp"
#include <tchar.h>
#include <process.h>
#include <fstream>
#include <vector> 
#include <string> 
#include <string.h>


#define BUFFER_SIZE 256
#define GLOBAL_LANGUAGE_ENGLISH 0
#define GLOBAL_LANGUAGE_DUTCH   1
#define GLOBAL_LANGUAGE_SPANISH 2
#define GLOBAL_LANGUAGE_ITALIAN 3
#define GLOBAL_LANGUAGE_SWEDISH 4
#define GLOBAL_LANGUAGE_FRENCH  5
#define GLOBAL_LANGUAGE_FINNISH 6
#define GLOBAL_LANGUAGE_POLISH  7
#define GLOBAL_LANGUAGE_GERMAN  8
#define GLOBAL_LANGUAGE_RUSSIAN 9
#define SYSTEM_VERSION_VISTA 500
#define SYSTEM_VERSION_XP    501
#define SYSTEM_VERSION_OTHER 502
#define STR_HIGHER           600
#define STR_LOWER            601
#define STR_EQUAL            602

int globalLanguageChosen; 
bool isEnglish = true; 
// bool globalLogShow = true; 
TCHAR * langList[] = { "English", "Nederlands", "Espaol", "Italiano", "Franais", "Suomi", "Deutsch" /* "Polski", "Svenska" */ } ;
TCHAR szText[BUFFER_SIZE];
HINSTANCE hInst;
HBITMAP g_hbmBall = NULL;

using namespace std;

class TextString { 
      public: 
              TextString(int, string); 
              int num; 
              string textData;
              
};

TextString::TextString(int newNum, string newTextData) { 
     num = newNum;
     textData = newTextData;       
}

vector<TextString> holdData;

void inspectElements() { 
     for ( int i = 0; i < holdData.size(); i++ ) { 
         string buffer(holdData[i].textData); 
         MessageBox(0, buffer.c_str(), 0, 0); 
     }     
}

void convertNewlines() { 
     for ( int i = 0; i < holdData.size(); i++ ) { 
         string line(holdData[i].textData); 
         string rp("\\n"); 
         size_t found = line.find(rp); 
         size_t len = 1; 
         
         while ( found != string::npos ) { 
              line.replace(found, rp.length(), len, 10);  
              // line[found] = 10; 
              found = line.find("\\n", found + 1); 
         }
         
         holdData[i].textData = line; 
     }
}

bool readFile(string fileName) { 
     ifstream file(fileName.c_str());
     if ( file.is_open() ) { 
         int num = 0; 
         string textData; 
                
         for ( string line; getline(file, line); ) { 
             string::size_type check = line.find_first_of("0123456789");
             if ( check == 0 ) { 
                  string::size_type position = line.find("|"); 
                  num = strtol(line.substr(0, position).c_str(), NULL, 10);  
                  textData = line.substr(position+1);  
                  TextString ts(num, textData);  
                  holdData.push_back(ts);
             }
         }
         
         file.close();
         return true; 
     }
     return false; 
}

bool checkData() { 
     return holdData[0].textData.empty(); 
}

bool loadLanguages(TCHAR * fileName) { 
     if ( readFile(fileName) ) {
          convertNewlines(); 
          return true;
     }
     
     return false; 
}

TCHAR * loadLogfile(TCHAR * logname) { 
     
     
     if ( !GetEnvironmentVariable("HOMEDRIVE", logname, 100) ) {
       GetEnvironmentVariable("TEMP", logname, 100);      
     }
    
     strcat(logname, "\\JavaRa.log");
     return logname; 
     
}



int GetSystemVersion()
{
    OSVERSIONINFOEX osvi;
    SYSTEM_INFO si;
    BOOL bOsVersionInfoEx;
    ZeroMemory(&si, sizeof(SYSTEM_INFO));
    ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
    // Try calling GetVersionEx using the OSVERSIONINFOEX structure.
    // If that fails, try using the OSVERSIONINFO structure.
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
    if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
    {
        osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
        if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
           return FALSE;
    }
    else GetSystemInfo(&si);
   
    switch (osvi.dwPlatformId)
    {
      // Test for the Windows NT product family.
      case VER_PLATFORM_WIN32_NT:
      // Test for the specific product.
      if ( osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0 )
      {
         if( osvi.wProductType == VER_NT_WORKSTATION )
         {
            // determined that Vista was found
            return SYSTEM_VERSION_VISTA;     
         }
      }
      if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 ) 
      {
         // determined that XP was found
         return SYSTEM_VERSION_XP; 
      }
      else if ( osvi.dwMajorVersion != 5 &&  osvi.dwMinorVersion != 1 && osvi.dwMajorVersion != 6 && osvi.dwMinorVersion != 0 )
      { 
           return SYSTEM_VERSION_OTHER; 
      }  
      break;
  }
}

int DeleteAny(TCHAR *envVar, TCHAR *cFileName)
{
    int fileOperationCheck;
    FILE *fp;
    TCHAR logname[100];
    fp = fopen(loadLogfile(logname), "a");
    TCHAR varOutput[MAX_PATH]; 
    ZeroMemory(varOutput, MAX_PATH); 
    if (!strcmp(envVar,"PROGRAMFILES"))
    {
      if (GetEnvironmentVariable("PROGRAMFILES(X86)", varOutput, MAX_PATH))
      {
        GetEnvironmentVariable("PROGRAMFILES(X86)", varOutput, MAX_PATH);
        // goto skip;
      }
    } else {
    
    GetEnvironmentVariable(envVar, varOutput, sizeof(varOutput)); 
    }
    
    // skip:    
    TCHAR temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcpy(temp, varOutput);
    lstrcat(temp, cFileName);
    lstrcat(temp, "\0");
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    fileOperationCheck = SHFileOperation(&folderFunction);
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        case ERROR_ACCESS_DENIED:
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
             fprintf(fp, "Could not delete: %s\r\nAsking Windows to delete %s on reboot.", temp);
        break;
        case ERROR_FILE_NOT_FOUND:
             // need to catch this case, but don't need to log it
             //      fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        case 1026:
             // need to catch this case, but don't need to log it
             //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        default:
             fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}
int RemoveFolders(TCHAR *javaPathRemember, TCHAR *cFileName)
{
    int fileOperationCheck;
    TCHAR logfile[100];
    FILE *fp;
    fp = fopen(loadLogfile(logfile), "a");
    TCHAR temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcpy(temp, javaPathRemember);
    lstrcat(temp, cFileName);
    lstrcat(temp, "\0");
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    fileOperationCheck = SHFileOperation(&folderFunction);
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        case ERROR_ACCESS_DENIED:
             fprintf(fp, "Could not delete: %s\r\nAsking Windows to delete %s on reboot.", temp);
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
        break;
        case ERROR_FILE_NOT_FOUND:
        //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        case 1026:
        //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        default:
             fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}
int RemoveRegKeys(HKEY regAddressOne, TCHAR *regAddressTwo, bool silent)
{
    int doesExist; 
    TCHAR buffer[255];
    TCHAR output[255];
    ZeroMemory(buffer, 255);
    ZeroMemory(output, 255); 
    TCHAR logname[100];
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
    FILE *fp;
    fp = fopen(logname, "a");
    HKEY hkey;
    int check = RegOpenKeyEx(regAddressOne, regAddressTwo, 0, KEY_SET_VALUE, &hkey);
    doesExist = SHDeleteKey(regAddressOne, regAddressTwo);
    RegCloseKey(hkey);
    TCHAR b[20];
    ZeroMemory(b, 20); 
    // fprintf(fp, "%s %i\r\n", regAddressTwo, doesExist); 
    // MessageBox(0, buffer, "doesExist", 0);
    if (doesExist == 0)
    {
       // TCHAR szOne[MAX_PATH];
       // ZeroMemory(szOne, MAX_PATH); 
       
       string szOne; 
       
       if ( isEnglish != true ) {
            szOne = holdData[33].textData; 
       }
       
       else { 
          szOne = "Found and removed:"; 
       }
       
       fprintf(fp, "Found and removed: %s\r\n", regAddressTwo);
       sprintf(buffer, "%s %s\r\n", szOne.c_str(), regAddressTwo);
       lstrcpy(output, buffer);
       if (silent != true) {
           MessageBox(0, output, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
       }
    }
    fclose(fp); 
}
int RemoveRegValues(HKEY regAddressOne, TCHAR *regAddressTwo, TCHAR *regAddressThree, bool silent)
{
    int doesExist;
    TCHAR buffer[255];
    TCHAR output[255];
    ZeroMemory(buffer, 255);
    ZeroMemory(output, 255); 
    
    FILE *fp;
    TCHAR logfile[100];
    fp = fopen(loadLogfile(logfile), "a");   
    HKEY hkey;
    RegOpenKeyEx(regAddressOne, regAddressTwo, 0, KEY_SET_VALUE, &hkey);
    doesExist = RegDeleteValue(hkey, regAddressThree);
    RegCloseKey(hkey);
    if (doesExist == 0)
    {
       string szOne;
      
       
       if ( isEnglish != true ) {
          szOne = holdData[33].textData; 
       }
       
       else { 
          szOne = "Found and removed:"; 
       }
       
      
       fprintf(fp, "Found and removed: %s\\%s\r\n", regAddressTwo, regAddressThree);
       sprintf(buffer, "%s %s\\%s", szOne.c_str(), regAddressTwo, regAddressThree);
       lstrcpy(output, buffer);
       if (silent != true)
       {
                  MessageBox(0, output, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
       }
    }
    fclose(fp); 
}
int DeleteTempFilesJava(TCHAR *environmentVariable, TCHAR *searchFlags)
{
    TCHAR toBeDeleted[MAX_PATH];
    TCHAR searchPath[MAX_PATH];
    TCHAR searchPathTwo[MAX_PATH]; 
    TCHAR ourPath[MAX_PATH]; 
    ZeroMemory(toBeDeleted, MAX_PATH); 
    ZeroMemory(searchPath, MAX_PATH); 
    ZeroMemory(searchPathTwo, MAX_PATH);
    ZeroMemory(ourPath, MAX_PATH);  
    lstrcpy(searchPath, environmentVariable);
    lstrcat(searchPath, "\\");
    lstrcat(searchPath, searchFlags);
    WIN32_FIND_DATA FindFileData;
    HANDLE hHandle = FindFirstFile(searchPath, &FindFileData);
    lstrcpy(toBeDeleted, environmentVariable);
    lstrcat(toBeDeleted, "\\");
    lstrcat(toBeDeleted, FindFileData.cFileName);
    DeleteFile(toBeDeleted);
    ZeroMemory(toBeDeleted, MAX_PATH);
    while ( FindNextFile(hHandle, &FindFileData) != 0 )
    {     
          lstrcpy(toBeDeleted, environmentVariable);
          lstrcat(toBeDeleted, "\\");
          lstrcat(toBeDeleted, FindFileData.cFileName);
          DeleteFile(toBeDeleted);
          ZeroMemory(toBeDeleted, MAX_PATH);
    }
}
int DeleteUselessJavaFiles(TCHAR *javaPathRemember, TCHAR *javaEnvironmentVariable, TCHAR *flags)
{
    TCHAR toBeDeleted[MAX_PATH];
    TCHAR searchPath[MAX_PATH];
    TCHAR searchPathTwo[MAX_PATH]; 
    TCHAR ourPath[MAX_PATH]; 
    ZeroMemory(toBeDeleted, MAX_PATH); 
    ZeroMemory(searchPath, MAX_PATH); 
    ZeroMemory(searchPathTwo, MAX_PATH);
    ZeroMemory(ourPath, MAX_PATH);  
    lstrcpy(toBeDeleted, javaPathRemember);
    lstrcpy(searchPathTwo, toBeDeleted); 
    lstrcat(searchPath, javaEnvironmentVariable); 
    DWORD dwError;
    WIN32_FIND_DATA FindFileData;
    HANDLE hHandle = FindFirstFile(searchPath, &FindFileData); 
    lstrcat(searchPathTwo, FindFileData.cFileName); 
    lstrcpy(ourPath, FindFileData.cFileName); 
    lstrcat(toBeDeleted, FindFileData.cFileName); 
    lstrcat(toBeDeleted, "\\");
    ZeroMemory(FindFileData.cFileName, sizeof(FindFileData.cFileName)); 
    lstrcat(searchPathTwo, flags);
    hHandle = FindFirstFile(searchPathTwo, &FindFileData); 
    lstrcat(toBeDeleted, FindFileData.cFileName);
    DeleteFile(toBeDeleted);
    ZeroMemory(toBeDeleted, MAX_PATH); 
    while ( FindNextFile(hHandle, &FindFileData) != 0 )
    {
          lstrcpy(toBeDeleted, javaPathRemember);
          lstrcat(toBeDeleted, ourPath); 
          lstrcat(toBeDeleted, "\\");
          lstrcat(toBeDeleted, FindFileData.cFileName); 
          DeleteFile(toBeDeleted); 
    }
    FindClose(hHandle); 
}

BOOL CALLBACK AboutDlgProc( HWND hDlgWnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{ 
      switch (message)
      {
             case WM_INITDIALOG:
             {
                  ConvertStaticToHyperlink(hDlgWnd, IDB_HYLNK);     
                  ConvertStaticToHyperlink(hDlgWnd, IDB_HYLNKTWO); 
                 
                  // string test("this is a test\r\ntest"); 
                  // SetDlgItemText(hDlgWnd, IDB_ABOUT_TEXT, test.c_str()); 
                 
                  
                       if ( isEnglish != true ) { 
                          if ( !SetDlgItemText(hDlgWnd, IDB_ABOUT_TEXT, holdData[24].textData.c_str()) ||  
                               !SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), holdData[25].textData.c_str()) ||
                               !SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), holdData[26].textData.c_str()) ) {
                                   SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), "Something is wrong"); 
                          }
                       }
             }
             return TRUE;
             case WM_DESTROY:
                   EndDialog(hDlgWnd, 0);
             return TRUE;
                 case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_HYLNK:
                         {
                              ShellExecute(hDlgWnd, "open", "http://raproducts.org", NULL, NULL, SW_SHOWNORMAL);
                              return TRUE;
                         }     
                         case IDB_HYLNKTWO:
                         {
                              ShellExecute(hDlgWnd, "open", "http://lunarsoft.net/forum/index.php?showforum=45", NULL, NULL, SW_SHOWNORMAL);
                              return TRUE;
                         }
                  }
                  break;
             }
             break;
      }
      return FALSE; 
}     
BOOL CALLBACK InstDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
             case WM_DESTROY:
                               EndDialog(hDlgWnd, 0);
             return TRUE;
                 case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             case WM_INITDIALOG:
             {
                  // TCHAR szOne[MAX_PATH]; 
                  // TCHAR szTwo[MAX_PATH];
                  
                  if ( isEnglish != true ) { 
                       if ( !SetDlgItemText(hDlgWnd, IDB_UINST, holdData[27].textData.c_str()) ||  
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), holdData[28].textData.c_str()) ) {
                               MessageBox(0, "Something is wrong", 0, 0); 
                       }
                  }
             }
             break;               
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_PAGE:
                         {
                              ShellExecute(NULL, "open", "http://java.sun.com/javase/downloads/index.jsp", NULL, NULL, SW_SHOWNORMAL);
                         }
                         break;
                  }
                  break;
             }
             break;
       }
       return FALSE;
}
BOOL CALLBACK UpdateDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
             case WM_DESTROY:
                               EndDialog(hDlgWnd, 0);
             return TRUE;
                 case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             case WM_INITDIALOG:
             {
                  if ( isEnglish != true ) { 
                       if ( !SetDlgItemText(hDlgWnd, IDB_UPDMAIN, holdData[18].textData.c_str()) ||  
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), holdData[19].textData.c_str()) ||
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), holdData[20].textData.c_str()) || 
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), holdData[21].textData.c_str()) ||
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), holdData[22].textData.c_str()) ||
                            !SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), holdData[23].textData.c_str()) ||
                            !SetWindowText(hDlgWnd, holdData[5].textData.c_str()) ) {
                       
                                SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), "Something is wrong"); 
                       }   
                  }
             }
             break;
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_UGO:
                         {
                              int checkOne = SendMessage( GetDlgItem(hDlgWnd, IDB_UJAVA), BM_GETCHECK, 0, 0 );
                              int checkTwo = SendMessage( GetDlgItem(hDlgWnd, IDB_USUN), BM_GETCHECK, 0, 0 );
                              if (checkOne == BST_CHECKED)
                              {
                                   TCHAR javaEnvironmentVariable[MAX_PATH];
                                   TCHAR fileToOpen[MAX_PATH];
                                   TCHAR is64Bit[MAX_PATH];
                                   ZeroMemory(fileToOpen, MAX_PATH); 
                                   ZeroMemory(javaEnvironmentVariable, MAX_PATH);
                                   if (!GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH))
                                   {
                                      GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                                      GetEnvironmentVariable("PROGRAMFILES", fileToOpen, MAX_PATH);
                                   } else {
                                      GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH);
                                      GetEnvironmentVariable("PROGRAMFILES(X86)", fileToOpen, MAX_PATH);
                                   }
                                   lstrcpy(fileToOpen, javaEnvironmentVariable);
                                   lstrcat(fileToOpen, "\\Java");
                                   lstrcat(javaEnvironmentVariable, "\\Java\\jre*");
                                   WIN32_FIND_DATA FindFileData;
                                   HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                                   lstrcat(fileToOpen, "\\");
                                   // MessageBox(0, FindFileData.cFileName, 0, 0); 
                                   lstrcat(fileToOpen, FindFileData.cFileName); 
                                   lstrcat(fileToOpen, "\\bin\\jucheck.exe");
                                   if ( ShellExecute(NULL, "open", fileToOpen, NULL, NULL, SW_SHOWNORMAL) != 0 ) {
                                        ZeroMemory(fileToOpen, MAX_PATH); 
                                        ZeroMemory(javaEnvironmentVariable, MAX_PATH);
                                        if (!GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH)) {
                                           GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                                           GetEnvironmentVariable("PROGRAMFILES", fileToOpen, MAX_PATH);
                                        } else {
                                          GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH);
                                          GetEnvironmentVariable("PROGRAMFILES(X86)", fileToOpen, MAX_PATH);
                                        }
                                        lstrcpy(fileToOpen, javaEnvironmentVariable);
                                        lstrcat(fileToOpen, "\\Common Files\\Java\\Java Update\\jucheck.exe");
                                        ShellExecute(NULL, "open", fileToOpen, NULL, NULL, SW_SHOWNORMAL);
                                   }
                                   FindClose(hHandle); 
                                   return TRUE; 
                              }
                              else if (checkTwo == BST_CHECKED)
                              {
                                   DialogBox(hInst, "INST_DIALOG", hDlgWnd, InstDlgProc); 
                              }
                         }
                         break;
                  }
                  break;
             }
             break; 
       }
        return FALSE; 
}
int removeSDM()
{
    DeleteAny("PROGRAMFILES", "\\SDM20");
    DeleteAny("USERPROFILE", "\\.SunDownloadManager"); 
    DeleteAny("USERPROFILE", "\\Start Menu\\Programs\\Sun Download Manager 2.0 (local)");
    DeleteAny("USERPROFILE", "\\Desktop\\Sun Download Manager 2.0 (local).lnk");
    TCHAR homeDrive[MAX_PATH];
    ZeroMemory(homeDrive, MAX_PATH); 
    GetEnvironmentVariable("HOMEDRIVE", homeDrive, 80);
    lstrcat(homeDrive, "\\Documents and Settings\\Administrator\\.SunDownloadManager");
    TCHAR logname[MAX_PATH];
    ZeroMemory(logname, MAX_PATH); 
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
    FILE *fp;
    fp = fopen(logname, "a");
    TCHAR temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcat(temp, homeDrive);
    lstrcat(temp, "\0");
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    int fileOperationCheck = SHFileOperation(&folderFunction);
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        case ERROR_ACCESS_DENIED:
             fprintf(fp, "Could not delete: %s\r\n\r\nAsking Windows to delete %s on reboot.", temp);
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
        break;
        case ERROR_FILE_NOT_FOUND:
        //     fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        case 1026:
        //      fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        default:
        //     fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}
int purgeFiles()
{
    TCHAR javaEnvironmentVariable[MAX_PATH];
    TCHAR tempEnvironmentVariable[MAX_PATH];
    TCHAR system32EnvironmentVariable[MAX_PATH];
    ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
    ZeroMemory(tempEnvironmentVariable, MAX_PATH);
    ZeroMemory(system32EnvironmentVariable, MAX_PATH);
    TCHAR javaPathRemember[MAX_PATH];
     if (!GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH))
    {
     GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
     GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
    } else {
     GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH);
     GetEnvironmentVariable("PROGRAMFILES(X86)", javaPathRemember, MAX_PATH);
    }
    GetEnvironmentVariable("TEMP", tempEnvironmentVariable, MAX_PATH);
    GetEnvironmentVariable("windir", system32EnvironmentVariable, MAX_PATH); 
    lstrcat(javaEnvironmentVariable, "\\Java\\jre*");
    lstrcat(javaPathRemember, "\\Java\\");
    lstrcat(system32EnvironmentVariable, "\\system32");
    DeleteUselessJavaFiles(javaPathRemember, javaEnvironmentVariable, "\\*.ERR");
    DeleteTempFilesJava(tempEnvironmentVariable, "java_*.log"); 
    DeleteTempFilesJava(tempEnvironmentVariable, "jusched.log"); 
    DeleteTempFilesJava(system32EnvironmentVariable, "jupdate*.log"); 
}
int RunJRERemove(bool silent, bool all)
{
                          TCHAR szOne[MAX_PATH];
                          TCHAR szTwo[MAX_PATH]; 
                          TCHAR szThree[MAX_PATH];
                          ZeroMemory(szOne, MAX_PATH); 
                          ZeroMemory(szTwo, MAX_PATH); 
                          ZeroMemory(szThree, MAX_PATH); 
                          
                           if ( silent != true) {
                              // #36
                              
                              if ( isEnglish != true ) { 
                                 MessageBox(0, holdData[36].textData.c_str(), "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
                              }
                              
                              else { 
                                   MessageBox(0, "In order for JavaRa to do its job in the most thorough way possible, Internet Explorer needs to be closed. If you are using Internet Explorer, please close it now.", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                              }
                           }

                           TCHAR logname[MAX_PATH];
                           ZeroMemory(logname, MAX_PATH); 
                          
                           if ( !GetEnvironmentVariable("HOMEDRIVE", logname, 100) ) {
                               GetEnvironmentVariable("TEMP", logname, 100); 
                           }
                          
                          strcat(logname, "\\JavaRa.log");
                          FILE *fp;
                          fp = fopen(logname, "a");
                          fputs("JavaRa 1.16 Removal Log.\r\nReport follows after line.\r\n", fp);
                          fputs("------------------------------------\r\n", fp);
                          time_t rawtime;
                          time ( &rawtime );
                          fprintf ( fp, "The JavaRa removal process was started on %s\n", ctime(&rawtime) );
                          fclose(fp);
                          KillProcess("jucheck.exe"); 
                          KillProcess("jusched.exe"); 
                          TCHAR buffer[MAX_PATH];
                          TCHAR temp[MAX_PATH];
                          TCHAR javaEnvironmentVariable[MAX_PATH];
                          TCHAR fileToRemember[MAX_PATH];
                          ZeroMemory(fileToRemember, MAX_PATH); 
                          ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
                          ZeroMemory(temp, MAX_PATH); 
                          ZeroMemory(buffer, MAX_PATH); 
                          TCHAR javaPathRemember[MAX_PATH];
                          ZeroMemory(javaPathRemember, MAX_PATH); 
                           if (!GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH))
                          {
                           GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                           GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
                          } else {
                           GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH);
                           GetEnvironmentVariable("PROGRAMFILES(X86)", javaPathRemember, MAX_PATH);
                          }
                          lstrcat(javaEnvironmentVariable, "\\Java\\j*re*");
                          lstrcat(javaPathRemember, "\\Java\\");
                          WIN32_FIND_DATA FindFileData;
                          HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                          lstrcpy(fileToRemember, FindFileData.cFileName);
                          if ( all == true ) { 
                             RemoveFolders(javaPathRemember, fileToRemember);    
                             return 1;   
                          }
                           while (FindNextFile(hHandle, &FindFileData) != 0) 
                           {
                                if ( all == true ) { 
                                   RemoveFolders(javaPathRemember, FindFileData.cFileName);      
                                }
                                else { 
                                    int check; 
                                    for ( int i = 0; i < 12; i++ )
                                    {
                                        check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                        if ( check > 0 )
                                           check = STR_HIGHER;
                                        else if ( check < 0 )
                                           check = STR_LOWER; 
                                        else if ( check == 0 ) 
                                           check = STR_EQUAL; 
                                        switch(check) 
                                        {
                                            case STR_HIGHER: 
                                                sprintf(temp, "Removed %s%s.\n", javaPathRemember, FindFileData.cFileName);
                                                lstrcat(buffer, temp); 
                                                RemoveFolders(javaPathRemember, FindFileData.cFileName);
                                                ZeroMemory(fileToRemember, MAX_PATH);
                                                lstrcpy(fileToRemember, FindFileData.cFileName);  
                                            break; 
                                            case STR_LOWER:  
                                                 sprintf(temp, "Removed %s%s.\n", javaPathRemember, fileToRemember);
                                                 lstrcat(buffer, temp); 
                                                 RemoveFolders(javaPathRemember, fileToRemember); 
                                                 ZeroMemory(fileToRemember, MAX_PATH); 
                                                 lstrcpy(fileToRemember, FindFileData.cFileName);
                                            break;
                                        }
                                    }
                                }
                           }                     
                           FindClose(hHandle); 
                           ZeroMemory(fileToRemember, MAX_PATH); 
                           int getSystem = GetSystemVersion();
                           switch(getSystem)
                           {
                                   case SYSTEM_VERSION_VISTA: 
                                        DeleteAny("USERPROFILE", "\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Java Plug-in Control Panel.ink"); 
                                        DeleteAny("PUBLIC", "\\Desktop\\Java Web Start.lnk"); 
                                        TCHAR appDataJavaPath[MAX_PATH];
                                        TCHAR appPathToRemember[MAX_PATH];
                                        GetEnvironmentVariable("USERPROFILE", appDataJavaPath, MAX_PATH);
                                        lstrcat(appDataJavaPath, "\\AppData\\LocalLow\\Sun\\Java\\j*re*"); 
                                        GetEnvironmentVariable("USERPROFILE", appPathToRemember, MAX_PATH);
                                        lstrcat(appPathToRemember, "\\AppData\\LocalLow\\Sun\\Java\\"); 
                                        hHandle = FindFirstFile(appDataJavaPath, &FindFileData); 
                                        lstrcpy(fileToRemember, FindFileData.cFileName);
                                         if ( all == true ) { 
                                            RemoveFolders(appDataJavaPath, fileToRemember);      
                                         }        
                                        while (FindNextFile(hHandle, &FindFileData) != 0) {
                                              if ( all == true ) { 
                                                 RemoveFolders(appDataJavaPath, FindFileData.cFileName);      
                                              }  
                                              for ( int i = 0; i < 12; i++ ) {
                                              int check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                              if ( check > 0 )
                                                 check = STR_HIGHER;
                                              else if ( check < 0 )
                                                 check = STR_LOWER; 
                                              else if ( check == 0 ) 
                                                 check = STR_EQUAL; 
                                              switch(check) {
                                                            case STR_HIGHER: 
                                                                 sprintf(temp, "Removed %s%s.\n", appPathToRemember, FindFileData.cFileName);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appPathToRemember, FindFileData.cFileName);
                                                                 ZeroMemory(fileToRemember, MAX_PATH);
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);  
                                                            break; 
                                                            case STR_LOWER:  
                                                                 sprintf(temp, "Removed %s%s.\n", appPathToRemember, fileToRemember);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appPathToRemember, fileToRemember); 
                                                                 ZeroMemory(fileToRemember, MAX_PATH); 
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);
                                                            break;
                                              }
                                           }
                                        }                     
                                        FindClose(hHandle); 
                                   break;
                                   case SYSTEM_VERSION_XP:
                                        DeleteAny("USERPROFILE", "\\Start Menu\\Programs\\Java Plug-in Control Panel.lnk");
                                        DeleteAny("ALLUSERSPROFILE", "\\Start Menu\\Programs\\Java 2 Runtime Environment");
                                        DeleteAny("USERPROFILE", "\\Local Settings\\Application Data\\{3248F0A6-6813-11D6-A77B-00B0D0150010}");
                                        TCHAR appJavaPath[MAX_PATH];
                                        TCHAR appToRemember[MAX_PATH];
                                        GetEnvironmentVariable("APPDATA", appJavaPath, MAX_PATH);
                                        lstrcat(appJavaPath, "\\Sun\\Java\\j*re*"); 
                                        GetEnvironmentVariable("APPDATA", appToRemember, MAX_PATH);
                                        lstrcat(appToRemember, "\\Sun\\Java\\"); 
                                        hHandle = FindFirstFile(appJavaPath, &FindFileData); 
                                        lstrcpy(fileToRemember, FindFileData.cFileName);
                                        while (FindNextFile(hHandle, &FindFileData) != 0) {
                                              for ( int i = 0; i < 12; i++ ) {
                                              int check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                              if ( check > 0 )
                                                 check = STR_HIGHER;
                                              else if ( check < 0 )
                                                 check = STR_LOWER; 
                                              else if ( check == 0 ) 
                                                 check = STR_EQUAL; 
                                              switch(check) {
                                                            case STR_HIGHER: 
                                                                 sprintf(temp, "Removed %s%s.\n", appToRemember, FindFileData.cFileName);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appToRemember, FindFileData.cFileName);
                                                                 ZeroMemory(fileToRemember, MAX_PATH);
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);  
                                                            break; 
                                                            case STR_LOWER:  
                                                                 sprintf(temp, "Removed %s%s.\n", appToRemember, fileToRemember);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appToRemember, fileToRemember); 
                                                                 ZeroMemory(fileToRemember, MAX_PATH); 
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);
                                                            break;
                                              }
                                           }
                                        }                     
                                        FindClose(hHandle); 
                                   break; 
                           } 
                           DeleteAny("SYSTEMROOT", "\\_delis43.ini");
                           DeleteAny("SYSTEMROOT", "\\jre.exe");
                           DeleteAny("SYSTEMROOT", "\\jrew.exe");
                           DeleteAny("USERPROFILE", "\\Desktop\\Java Web Start.lnk"); 
                           DeleteAny("PROGRAMFILES", "\\Java Web Start");
                            DeleteAny("SYSTEMROOT", "\\5390d.msi");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150010}");
                           DeleteAny("SYSTEMROOT", "\\System32\\jpicpl32.cpl");
                           DeleteAny("SYSTEMROOT", "\\System32\\jupdate-1.5.0_01-b08.log");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142000}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142010}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142020}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142030}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142040}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142050}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142060}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142070}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142080}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142090}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142100}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142110}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142120}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142130}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142140}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142150}");
                           DeleteAny("SYSTEMROOT", "\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142160}");                            
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_01.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_02.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_03.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_04.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_05.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_06.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_07.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_08.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_09.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_10.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_11.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_12.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_13.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_14.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_15.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_16.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_17.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_18.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_19.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl131_20.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130.cpl"); 
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130_01.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130_02.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130_03.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130_04.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl130_05.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl140.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl140_01.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl140_02.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl140_03.cpl");
                           DeleteAny("SYSTEMROOT", "\\system32\\plugincpl140_04.cpl");
                          
                          TCHAR theLine[MAX_PATH];
                          ZeroMemory ( theLine, MAX_PATH );
                          FILE * ep = fopen( "JavaRa.def", "r" );
                          if ( ep != NULL ) 
                          {
                               while ( fgets(theLine, MAX_PATH, ep) ) 
                               {  
                                     TCHAR * line = strtok(theLine, "|"); 
                                     int i = 0; 
                                     HKEY regHandle;
                                     TCHAR * keyPath = NULL;
                                     TCHAR * valuePath = NULL; 
                                     while ( line != NULL ) { 
                                           if ( i == 0 ) {
                                                if ( strcmp(line, "HKEY_LOCAL_MACHINE") == 0 ) {
                                                   regHandle = HKEY_LOCAL_MACHINE;
                                                }
                                                if ( strcmp(line, "HKEY_CURRENT_USER") == 0 ) {
                                                   regHandle = HKEY_CURRENT_USER;
                                                }
                                                if ( strcmp(line, "HKEY_CLASSES_ROOT") == 0 ) {
                                                   regHandle = HKEY_CLASSES_ROOT; 
                                                }
                                           }
                                           if ( i == 1 ) { 
                                              keyPath = line;
                                           }
                                           if ( i == 2 ) { 
                                              valuePath = line; 
                                           }
                                           i++;
                                           line = strtok(NULL, "|"); 
                                     }
                                     if ( regHandle != NULL ) {
                                        if ( keyPath != NULL ) {
                                          if ( valuePath != NULL ) { 
                                               valuePath = strtok(valuePath, "\n"); 
                                               RemoveRegValues(regHandle, keyPath, valuePath, true); 
                                          }
                                          else { 
                                               keyPath = strtok(keyPath, "\n"); 
                                               RemoveRegKeys(regHandle, keyPath, true); 
                                          }
                                        }  
                                     }
                               }
                               fclose(ep);
                          }        
                         else if ( ep == NULL && silent != true ) { 
                                if ( isEnglish != true ) { 
                                   MessageBox(0, holdData[37].textData.c_str(), "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
                                }
                              
                              else { 
                                   MessageBox(0, "Could not find JavaRa.def! Be sure the definition file resides in the same directory JavaRa.exe is in.", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                              }
                                
                                //TCHAR message[MAX_PATH] = "Could not find JavaRa.def! Be sure the definition file resides in the same directory JavaRa.exe is in.";
//                                
//                                switch ( globalLanguageChosen ) { 
//                                       case GLOBAL_LANGUAGE_DUTCH: 
//                                            lstrcpy(message, "Kan niet vinden JavaRa.def! Wees er zeker van de definitie-bestand bevindt zich in dezelfde directory JavaRa.exe zich bevindt.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_SPANISH: 
//                                            lstrcpy(message, "No se pudo encontrar JavaRa.def! Asegrese de que el archivo de definicin reside en el mismo directorio que se encuentra JavaRa.exe.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_ITALIAN: 
//                                            lstrcpy(message, "Impossibile trovare JavaRa.def! Assicurarsi che il file di definizione risiede nella stessa directory si trova JavaRa.exe.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_SWEDISH: 
//                                            lstrcpy(message, "Kunde inte hitta JavaRa.def! Var noga med definitionen filen finns i samma katalog JavaRa.exe r i.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_FRENCH:
//                                            lstrcpy(message, "Impossible de trouver JavaRa.def! Assurez-vous que le fichier de dfinition rside dans le mme rpertoire JavaRa.exe est po.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_FINNISH:
//                                            lstrcpy(message, "Ei lytynyt JavaRa.def! Varmista, ett mritelm tiedosto asuu samassa hakemistossa JavaRa.exe on sisn.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_POLISH: 
//                                            lstrcpy(message, "Nie moz.na znalez'c' JavaRa.def! Upewnij sie;, z.e plik definicji mieszka w tym samym katalogu JavaRa.exe jest cala.");
//                                       break;
//                                       case GLOBAL_LANGUAGE_GERMAN:
//                                            lstrcpy(message, "Konnte nicht gefunden JavaRa.def! Stellen Sie sicher, dass die Definition Datei befindet sich im selben Verzeichnis JavaRa.exe ist in.");
//                                       break;
//                                }
//                                
//                                MessageBox(0, message, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                          } 
                          DeleteAny("PROGRAMFILES", "\\JavaSoft"); 
                          fp = fopen(logname, "a");
                          fputs("------------------------------------\r\nFinished reporting.\r\n\r\n", fp);
                          fclose(fp); 
                          if ( strcmp(temp, "") != 0 && silent != true) 
                          {
                               MessageBox(0, buffer, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
                          }
                          return FALSE; 
}
BOOL CALLBACK OptionsDlgProc (HWND hDlgWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
             case WM_DESTROY:
                               EndDialog(hDlgWnd, 0);
             return TRUE;
                 case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             case WM_INITDIALOG:
             {
                  if ( isEnglish != true ) { 
                     if ( !SetWindowText(hDlgWnd, holdData[7].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), holdData[9].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), holdData[10].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), holdData[11].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), holdData[12].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), holdData[13].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), holdData[14].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), holdData[15].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), holdData[17].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), holdData[31].textData.c_str()) ||
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), holdData[32].textData.c_str()) || 
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_BHO), holdData[34].textData.c_str()) || 
                          !SetWindowText(GetDlgItem(hDlgWnd, IDB_FCONS), holdData[35].textData.c_str()) ) {
                          
                          MessageBox(0, "Something is bad wrong.", 0, 0); 
                     }
                  }
             }
             break; 
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_DONATE:
                         {
                               ShellExecute(NULL, "open", "http://raproducts.org/supportus.html", NULL, NULL, SW_SHOWNORMAL); 
                         }
                         break;
                         case IDB_GO:
                         {
                             int checkBoxOne = SendMessage( GetDlgItem(hDlgWnd, IDB_CLEAN), BM_GETCHECK, 0, 0);
                             int checkBoxTwo = SendMessage( GetDlgItem(hDlgWnd, IDB_STARTUP), BM_GETCHECK, 0, 0); 
                             int checkBoxThree = SendMessage( GetDlgItem(hDlgWnd, IDB_UPDATE), BM_GETCHECK, 0, 0);
                             int checkBoxFour = SendMessage ( GetDlgItem(hDlgWnd, IDB_JRLOG), BM_GETCHECK, 0, 0);
                             int checkBoxFive = SendMessage ( GetDlgItem(hDlgWnd, IDB_SDMRM), BM_GETCHECK, 0, 0);
                             int checkBoxSix = SendMessage ( GetDlgItem(hDlgWnd, IDB_OPNLG), BM_GETCHECK, 0, 0);
                             int checkBoxSeven = SendMessage ( GetDlgItem(hDlgWnd, IDB_RMREG), BM_GETCHECK, 0, 0); 
                             int checkBoxEight = SendMessage ( GetDlgItem(hDlgWnd, IDB_CHKVER), BM_GETCHECK, 0, 0);
                             //I added this...
                             int checkBoxNine = SendMessage ( GetDlgItem(hDlgWnd, IDB_BHO), BM_GETCHECK, 0, 0); 
                             int checkBoxTen = SendMessage ( GetDlgItem(hDlgWnd, IDB_FCONS), BM_GETCHECK, 0, 0); 
                             if (checkBoxOne == BST_CHECKED) 
                             {
                                 purgeFiles();
                                 SendMessage( GetDlgItem(hDlgWnd, IDB_CLEAN), BM_SETCHECK, BST_UNCHECKED, 0); 
                                 TCHAR szOne[MAX_PATH];
                                 ZeroMemory(szOne, MAX_PATH); 
                                 switch(globalLanguageChosen)
                                 {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for useless JRE files.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda de archivos intiles JRE."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Voltooid op zoek naar nutteloze JRE-bestanden.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito inutile ricerca di JRE file.");
                                        default:
                                             lstrcpy(szOne, "Finished searching for useless JRE files."); 
                                        break;
                                        case GLOBAL_LANGUAGE_FINNISH:
                                             lstrcpy(szOne, "Pttynyt etsivt hydytn JRE-tiedostoja.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH:
                                             lstrcpy(szOne, "Terminer la recherche de fichiers inutiles JRE.");
                                        break; 
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ska efter meningsls JRE filer.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH:
                                             lstrcpy(szOne, "Zakon'czono poszukiwania bezuz.yteczne JRE plikw.");
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Erledigt der Suche nach nutzlos JRE-Dateien."); 
                                        break; 
                                 }
                                 MessageBox(0, szOne, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
                             }
                             if (checkBoxTwo == BST_CHECKED)
                             {
                                  RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", "SunJavaUpdateSched", false);
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_STARTUP), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
                                  switch(globalLanguageChosen)
                                  {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for JRE startup entries.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda de JRE entradas de lanzamiento."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Afgewerkt zoeken naar JRE opstart-items.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito di JRE ricerca di voci di avvio."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH:
                                             lstrcpy(szOne, "Pttynyt etsivt JRE startup entries.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Terminer la recherche de JRE entres de dmarrage.");
                                        break;
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ska efter JRE start poster.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH:
                                             lstrcpy(szOne, "Zakon'czono poszukiwania JRE pozycje startowe."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Erledigt der Suche nach JRE-Start-Eintrge."); 
                                        break;                                         
                                        default:
                                             lstrcpy(szOne, "Finished searching for JRE startup entries."); 
                                        break;
                                  }
                                  MessageBox(0, szOne, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                             }
                             if (checkBoxThree == BST_CHECKED)
                             {
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_UPDATE), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  ShellExecute(NULL, "open", "http://raproducts.org/click/click.php?id=1", NULL, NULL, SW_SHOWNORMAL); 
                             }
                             if (checkBoxFour == BST_CHECKED)
                             {
                                  TCHAR envVar[255];
                                  if ( GetEnvironmentVariable("HOMEDRIVE", envVar, 255) == 0 ) {
                                       GetEnvironmentVariable("TEMP", envVar, 255); 
                                  } 
                                  strcat(envVar, "\\JavaRa.log");
                                  DeleteFile(envVar); 
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_JRLOG), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
                                  switch(globalLanguageChosen)
                                  {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished removing the JavaRa logfile.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizar la eliminacin de la JavaRa logfile."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Voltooid het verwijderen van de JavaRa logfile.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito di rimuovere la JavaRa file di log."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH: 
                                             lstrcpy(szOne, "Pttynyt poistamalla JavaRa logfile."); 
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Termin liminer les JavaRa fichier journal.");
                                        break;
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ta bort JavaRa loggfil."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH: 
                                             lstrcpy(szOne, "Zakon'czono usunie;cie JavaRa logfile."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN: 
                                             lstrcpy(szOne, "Fertig Entfernen der JavaRa Logfile.");
                                        break; 
                                        default:
                                             lstrcpy(szOne, "Finished removing the JavaRa logfile."); 
                                        break;
                                  }
                                  MessageBox(0, szOne, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                             }
                             if (checkBoxFive == BST_CHECKED)
                             {
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
                                  switch(globalLanguageChosen)
                                  {
                                         case GLOBAL_LANGUAGE_ENGLISH:
                                              LoadString(hInst, ENG_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         case GLOBAL_LANGUAGE_DUTCH:
                                              LoadString(hInst, DUT_Q3, szOne, sizeof(szOne));
                                         break;
                                         case GLOBAL_LANGUAGE_SPANISH:
                                              LoadString(hInst, ESP_Q3, szOne, sizeof(szOne));
                                         break;
                                         case GLOBAL_LANGUAGE_ITALIAN:
                                              LoadString(hInst, ITA_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         case GLOBAL_LANGUAGE_SWEDISH:
                                              LoadString(hInst, SVE_Q3, szOne, sizeof(szOne));
                                         break;
                                         case GLOBAL_LANGUAGE_FRENCH:
                                              LoadString(hInst, FRA_Q3, szOne, sizeof(szOne)); 
                                         break;
                                         case GLOBAL_LANGUAGE_FINNISH:
                                              LoadString(hInst, FIN_Q3, szOne, sizeof(szOne));
                                         break; 
                                         case GLOBAL_LANGUAGE_POLISH: 
                                              LoadString(hInst, POL_Q3, szOne, sizeof(szOne)); 
                                         break;
                                         case GLOBAL_LANGUAGE_GERMAN: 
                                              LoadString(hInst, GER_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         default: 
                                              LoadString(hInst, ENG_Q3, szOne, sizeof(szOne));
                                         break; 
                                  }
                                  if ( MessageBox(0, szOne, "JavaRa 1.16", MB_YESNO | MB_ICONQUESTION) == IDYES)
                                  {
                                       removeSDM(); 
                                       TCHAR szOne[MAX_PATH];
                                       ZeroMemory(szOne, MAX_PATH); 
                                       switch(globalLanguageChosen)
                                       {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for and removing the Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda y eliminacin de la transferencia directa del Sol."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Gereed voor het zoeken en verwijderen van de Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito per la ricerca e la rimozione della Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH: 
                                             lstrcpy(szOne, "Pttynyt etsi ja poistaa Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Termin pour la recherche et de supprimer la gestionnaire de tlchargement de Sun.");
                                        break; 
                                        case GLOBAL_LANGUAGE_SWEDISH: 
                                             lstrcpy(szOne, "Klar att ska efter och ta bort Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH: 
                                             lstrcpy(szOne, "Zakon'czono poszukiwania i usuwania Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Fertig fr die Suche und das Entfernen der Sun Download-Manager."); 
                                        break; 
                                        default:
                                             lstrcpy(szOne, "Finished searching for and removing the Sun Download Manager."); 
                                        break;
                                       }
                                       MessageBox(0, szOne, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                                  }
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_SDMRM), BM_SETCHECK, BST_UNCHECKED, 0); 
                             }
                             if (checkBoxSix == BST_CHECKED)
                             {
                                   TCHAR envVar[255];
                                   if ( GetEnvironmentVariable("HOMEDRIVE", envVar, 255) == 0 ) { 
                                        GetEnvironmentVariable("TEMP", envVar, 255);
                                   }
                                   strcat(envVar, "\\JavaRa.log");
                                   ShellExecute(NULL, "open", envVar, NULL, NULL, SW_SHOWNORMAL); 
                                   SendMessage( GetDlgItem(hDlgWnd, IDB_OPNLG), BM_SETCHECK, BST_UNCHECKED, 0); 
                             }
                             if (checkBoxSeven == BST_CHECKED)
                             {
                                    RemoveRegKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", false);
                             }
                             if ( checkBoxEight == BST_CHECKED ) { 
                                   SendMessage( GetDlgItem(hDlgWnd, IDB_CHKVER), BM_SETCHECK, BST_UNCHECKED, 0); 
                                   TCHAR buffer[MAX_PATH];
                                   TCHAR temp[MAX_PATH];
                                   TCHAR javaEnvironmentVariable[MAX_PATH];
                                   TCHAR fileToRemember[MAX_PATH];
                                   TCHAR lpszFilePath[MAX_PATH]; 
                                   ZeroMemory(fileToRemember, MAX_PATH); 
                                   ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
                                   ZeroMemory(temp, MAX_PATH); 
                                   ZeroMemory(buffer, MAX_PATH); 
                                   TCHAR javaPathRemember[MAX_PATH];
                                   if (!GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH))
                                   {
                                   GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                                   GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
                                   } else {
                                   GetEnvironmentVariable("PROGRAMFILES(X86)", javaEnvironmentVariable, MAX_PATH);
                                   GetEnvironmentVariable("PROGRAMFILES(X86)", javaPathRemember, MAX_PATH);
                                   }
                                   lstrcat(javaEnvironmentVariable, "\\Java\\j*re*");
                                   lstrcat(javaPathRemember, "\\Java\\");
                                   WIN32_FIND_DATA FindFileData;
                                   HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                                   lstrcpy(fileToRemember, FindFileData.cFileName);
                                   // fix
                                   if ( strcmp(FindFileData.cFileName, "") == 0 ) { 
                                      break;
                                   }
                                   lstrcpy(lpszFilePath, javaPathRemember); 
                                   lstrcat(lpszFilePath, FindFileData.cFileName); 
                                   lstrcat(lpszFilePath, "\\bin\\java.exe"); 
                                   while (FindNextFile(hHandle, &FindFileData) != 0) {
                                         int check = 0; 
                                         for ( int i = 0; i < 12; i++ ) {
                                             check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                             if ( check > 0 )
                                                  check = STR_HIGHER;
                                             else if ( check < 0 )
                                                  check = STR_LOWER; 
                                             else if ( check == 0 ) 
                                                  check = STR_EQUAL; 
                                             switch(check) {
                                                  case STR_HIGHER: 
                                                  case STR_LOWER: 
                                                  case STR_EQUAL: 
                                                      lstrcpy(lpszFilePath, javaPathRemember); 
                                                      lstrcat(lpszFilePath, FindFileData.cFileName); 
                                                      lstrcat(lpszFilePath, "\\bin\\java.exe"); 
                                                  break; 
                                            }
                                       }
                                }                     
                                FindClose(hHandle); 
                                ZeroMemory(fileToRemember, MAX_PATH); 
                                DWORD dwDummy;
                                DWORD dwFVISize = GetFileVersionInfoSize( lpszFilePath , &dwDummy );
                                LPBYTE lpVersionInfo = new BYTE[dwFVISize];
                                GetFileVersionInfo( lpszFilePath , 0 , dwFVISize , lpVersionInfo );
                                UINT uLen;
                                VS_FIXEDFILEINFO *lpFfi;
                                VerQueryValue( lpVersionInfo , _T("\\") , (LPVOID *)&lpFfi , &uLen );
                                DWORD dwFileVersionMS = lpFfi->dwFileVersionMS;
                                DWORD dwFileVersionLS = lpFfi->dwFileVersionLS;
                                delete [] lpVersionInfo;
                                DWORD dwLeftMost = HIWORD(dwFileVersionMS);
                                DWORD dwSecondLeft = LOWORD(dwFileVersionMS);
                                DWORD dwSecondRight = HIWORD(dwFileVersionLS);
                                DWORD dwRightMost = LOWORD(dwFileVersionLS);
                                sprintf(buffer, "Java JRE version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                switch ( globalLanguageChosen ) { 
                                       case GLOBAL_LANGUAGE_DUTCH: 
                                            sprintf(buffer, "Java JRE-versie: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break; 
                                       case GLOBAL_LANGUAGE_SPANISH: 
                                            sprintf(buffer, "Java JRE versin: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_ITALIAN: 
                                            sprintf(buffer, "Java JRE versione: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_SWEDISH: 
                                            sprintf(buffer, "Java JRE-version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_FRENCH: 
                                            sprintf(buffer, "Java JRE version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_FINNISH: 
                                            sprintf(buffer, "Java JRE versio: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_POLISH: 
                                            sprintf(buffer, "Java JRE wersji: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_GERMAN: 
                                            sprintf(buffer, "Java JRE-Version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                }
                                MessageBox(0, buffer, "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);  
                             }
                             if (checkBoxNine == BST_CHECKED) 
                             {
                                              RemoveRegKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\explorer\\Browser Helper Objects\\{DBC80044-A445-435b-BC74-9C25C1C588A9}", false);
                                              RemoveRegKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\CLSID\\{DBC80044-A445-435b-BC74-9C25C1C588A9}", false);
                                              RemoveRegKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Wow6432Node\\CLSID\\{DBC80044-A445-435b-BC74-9C25C1C588A9}", false);
                                              RemoveRegKeys(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Ext\\Settings\\{DBC80044-A445-435B-BC74-9C25C1C588A9}", false);
                                              RemoveRegKeys(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Ext\\Stats\\{DBC80044-A445-435B-BC74-9C25C1C588A9}", false);
                                              SendMessage( GetDlgItem(hDlgWnd, IDB_BHO), BM_SETCHECK, BST_UNCHECKED, 0);
                             }
                             if ( checkBoxTen == BST_CHECKED ) { 
                                MessageBox(0, "Please close any instances of Mozilla Firefox you are running.\n\nThis will remove all instances of the Java Console Extension from Firefox.", "JavaRa", MB_OK | MB_ICONINFORMATION ); 
                                TCHAR fPath[MAX_PATH];
                                if (!GetEnvironmentVariable("PROGRAMFILES(X86)", fPath, MAX_PATH))
                                {
                                 GetEnvironmentVariable("PROGRAMFILES", fPath, MAX_PATH);
                                } else {
                                 GetEnvironmentVariable("PROGRAMFILES(X86)", fPath, MAX_PATH);
                                } 
                                lstrcat(fPath, "\\Mozilla Firefox\\extensions\\{CAFEEFAC-0016-0000-00**-ABCDEFFEDCBA}"); 
                                WIN32_FIND_DATA FindFileData;
                                HANDLE hHandle = FindFirstFile(fPath, &FindFileData); 
                                // MessageBox(0, FindFileData.cFileName, 0, 0);
                                TCHAR toDelete[80] = "\\Mozilla Firefox\\extensions\\"; 
                                lstrcat(toDelete, FindFileData.cFileName);
                                DeleteAny(fPath, toDelete); 
                                ZeroMemory(toDelete, MAX_PATH); 
                                while (FindNextFile(hHandle, &FindFileData) != 0) {
                                      lstrcpy(toDelete, "\\Mozilla Firefox\\extensions\\"); 
                                      lstrcat(toDelete, FindFileData.cFileName);
                                      DeleteAny(fPath, toDelete); 
                                      ZeroMemory(toDelete, MAX_PATH); 
                                }
                             }
                         }
                         break; 
                  }
                  break;
             }
             break;
       }
       return FALSE; 
}

void setMessage(string szOne, string szTwo) {
     if ( MessageBox(0, szOne.c_str(), "JavaRa 1.16", MB_YESNO | MB_ICONQUESTION) == IDYES ) {
          RunJRERemove(false, false); 
          MessageBox(0, szTwo.c_str(), "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
          TCHAR envVar[255];
                          
          if ( GetEnvironmentVariable("HOMEDRIVE", envVar, 255) == 0 ) { 
             GetEnvironmentVariable("TEMP", envVar, 255); 
          }
          strcat(envVar, "\\JavaRa.log");
          ShellExecute(NULL, "open", envVar, NULL, NULL, SW_SHOWNORMAL);  
     }
}

BOOL CALLBACK InitProc( HWND hDlgWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{
      HMENU hMenu = GetSystemMenu(hDlgWnd, FALSE);
      RemoveMenu(hMenu, SC_RESTORE, MF_BYCOMMAND);
      RemoveMenu(hMenu, SC_SIZE, MF_BYCOMMAND);
      RemoveMenu(hMenu, SC_MAXIMIZE, MF_BYCOMMAND);
      switch(Message)
      {
        case WM_INITDIALOG:
        {
            g_hbmBall = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_IMAGE));
            DWORD dwStyle = GetWindowLong(hDlgWnd, GWL_STYLE);
            SetWindowLong(hDlgWnd, GWL_STYLE, dwStyle | SS_NOTIFY);
            RECT DesktopRect;
            RECT DialogRect;
            GetWindowRect(GetDesktopWindow(), &DesktopRect);
            GetWindowRect(hDlgWnd, &DialogRect);
            SetWindowPos(hDlgWnd, HWND_TOP, (DesktopRect.right - DialogRect.right) / 2, (DesktopRect.bottom - DialogRect.bottom) / 2, 0, 0, SWP_NOSIZE );
            SendMessage(hDlgWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
            SendMessage(hDlgWnd, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
            
            
            if ( isEnglish != true ) { 
                  if ( !SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), holdData[4].textData.c_str()) ||
                       !SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), holdData[5].textData.c_str()) ||
                       !SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), holdData[6].textData.c_str()) ||
                       !SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), holdData[7].textData.c_str()) ||
                       !SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), holdData[8].textData.c_str()) ) { 
                              MessageBox(0, "Something is bad wrong.", 0, 0);                  
                  } 
            }
            
            return TRUE;
        }
        break;
        case WM_PAINT:
        {
             PAINTSTRUCT ps;
             BITMAP bm;
             HDC hdc = BeginPaint(hDlgWnd, &ps);
             HBITMAP foo = LoadBitmap (hInst, MAKEINTRESOURCE(IDB_IMAGE));
             HDC memDC = CreateCompatibleDC (hdc);
             int save = SaveDC (memDC);
             SelectObject (memDC, foo);
             BitBlt (hdc, 12, 12, 32, 32, memDC, 0, 0, SRCCOPY);
             RestoreDC (memDC, save);
             EndPaint(hDlgWnd, &ps);
             DeleteObject (foo);
        }
        break;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDB_ABOUT:
                {
                     DialogBox(hInst, "ABOUT_DIALOG", hDlgWnd, AboutDlgProc); 
                }
                break;
                case IDB_SEARCH:
                {
                     DialogBox(hInst, "UPDATE_DIALOG", hDlgWnd, UpdateDlgProc);
                }
                break;
                case IDB_OPTIONS:
                {
                     DialogBox(hInst, "OPTIONS_DIALOG", hDlgWnd, OptionsDlgProc);
                }
                break;
                case IDB_REMOVE:
                {
                     if ( isEnglish != true ) { 
                          setMessage(holdData[1].textData, holdData[2].textData); 
                     }
                     
                     else {
                          setMessage("This will remove all older versions of the Java JRE that JavaRa finds.\n\nAre you sure you want to proceed?", "Finished searching for all old versions of the JRE that were found on this system. A logfile has been created on your system. It is called JavaRa.log, and can be found in your main hard drive folder (C: for example).\n\nJavaRa will now open its logfile."); 
                     }
                }
                break;
            }
        break;
        case WM_CLOSE:
             EndDialog(hDlgWnd, 0);
             DestroyWindow(hDlgWnd);
        break;
        case WM_DESTROY:
             EndDialog (hDlgWnd, 0);
             PostQuitMessage(0);
        break;
    }
    return FALSE;
}
BOOL CALLBACK LangDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
             case WM_DESTROY:
                               EndDialog(hDlgWnd, 0);
                               PostQuitMessage(0);
             return TRUE;
                 case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
                  DestroyWindow(hDlgWnd); 
             break;
             case WM_INITDIALOG:
             {
                  RECT DesktopRect;
                  RECT DialogRect;
                  GetWindowRect(GetDesktopWindow(), &DesktopRect);
                  GetWindowRect(hDlgWnd, &DialogRect);
                  SetWindowPos(hDlgWnd, HWND_TOP, (DesktopRect.right - DialogRect.right) / 2, (DesktopRect.bottom - DialogRect.bottom) / 2, 0, 0, SWP_NOSIZE );
                  SendMessage(hDlgWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
                  SendMessage(hDlgWnd, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
                  for (int i = 0; i < 7; i++)
                  {
                      SendDlgItemMessage(hDlgWnd, IDB_LANGCBO, CB_ADDSTRING, 0, (LPARAM)langList[i]);
                  }
                  DWORD dwSize = 0; 
                  DWORD dwType = REG_SZ; 
                  HKEY hKey;
                  if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS )
                  {
                       if ( RegQueryValueEx(hKey, "JavaRa", NULL, NULL, NULL, &dwSize) == ERROR_SUCCESS )
                       {
                           RegQueryValueEx(hKey, "JavaRa", NULL, NULL, (LPBYTE)NULL, &dwSize); 
                           TCHAR * regSelection = new TCHAR[dwSize / sizeof(TCHAR)];
                           RegQueryValueEx(hKey, "JavaRa", NULL, NULL, (LPBYTE)regSelection, &dwSize); 
                           HWND hWnd;
                           // TCHAR * langList[] = { "English", "Nederlands", "Espaol", "Italiano", "Svenska", "Franais", "Suomi", "Polski", "Deutsch" } ;
                           
                           for ( int i = 0; i < 7; i++ ) { 
                               if ( lstrcmp(regSelection, langList[i]) == 0 && lstrcmp(regSelection, "English") != 0 ) { 
                                   // globalLanguageChosen = i;
                                   isEnglish = false; 
                                   strcat(regSelection, ".lng"); 
                                      
                                   if ( loadLanguages(regSelection) == false ) { 
                                      MessageBox(0, "Error opening language file. Defaulting to English.", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                                      isEnglish = true;
                                   }
                               }
                           }
                                    
                           EndDialog(hDlgWnd, 0);
                           hWnd = CreateDialog( hInst, (LPCTSTR)"DIALOG_NAME", NULL, (DLGPROC)InitProc );
                           RegCloseKey(hKey); 
                           delete [] regSelection; 
                       }
                  }
             }
             break; 
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_IGO:
                         {
                              int getSelected = SendMessage(GetDlgItem(hDlgWnd, IDB_LANGCBO), CB_GETCURSEL, 0, 0);
                              globalLanguageChosen = getSelected;
                              
                              TCHAR gottenListboxText[MAX_PATH];
                              ZeroMemory(gottenListboxText, MAX_PATH); 
                              SendMessage(GetDlgItem(hDlgWnd, IDB_LANGCBO), CB_GETLBTEXT, getSelected, (LPARAM)gottenListboxText);
                              
                              if ( getSelected != CB_ERR ) { 
                                   if ( strcmp(gottenListboxText, "English") != 0 ) { 
                                       isEnglish = false; 
                                       strcat(gottenListboxText, ".lng"); 
                                      
                                       if ( loadLanguages(gottenListboxText) == false ) { 
                                          MessageBox(0, "Error opening language file. Defaulting to English.", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                                          isEnglish = true;
                                       }
                                   } 
                              }
                              
                              else if (getSelected == CB_ERR) {
                                  MessageBox(0, "Please select a language.", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION);
                                  break; 
                              }
                              
                              int checkBoxOne = SendMessage( GetDlgItem(hDlgWnd, IDB_LANGCHK), BM_GETCHECK, 0, 0); 
                              if (checkBoxOne == BST_CHECKED) {
                                    int regCheck; 
                                    HKEY hKey;
                                    regCheck = RegCreateKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", &hKey);
                                    if (regCheck == 0) {
                                        TCHAR gottenListboxText[MAX_PATH];
                                        ZeroMemory(gottenListboxText, MAX_PATH); 
                                        SendMessage(GetDlgItem(hDlgWnd, IDB_LANGCBO), CB_GETLBTEXT, getSelected, (LPARAM)gottenListboxText); 
                                        RegSetValueEx( (HKEY) hKey, "JavaRa", 0, REG_SZ, (BYTE *)gottenListboxText, strlen(gottenListboxText) );
                                        RegCloseKey(hKey); 
                                    }
                                    
                                    else if ( regCheck != 0 ) { 
                                         MessageBox(0, "Unable to create registry key!", "JavaRa 1.16", MB_OK | MB_ICONINFORMATION); 
                                    }
                              }
                              EndDialog(hDlgWnd, 0);
                              HWND hWnd = CreateDialog( hInst, (LPCTSTR)"DIALOG_NAME", NULL, (DLGPROC)InitProc );
                         }
                         break; 
                  }
                  break;
             }
             break;
        }
        return FALSE;
}
unsigned _stdcall Thread(void* args) { 
     RunJRERemove(true, false);
}
//unsigned _stdcall SecondThread(void* args) { 
//     // MessageBox(0, "in thread", 0, 0); 
//     RunJRERemove(true, true);
//     // _endthread(); 
//}

// thanks to Ruben 
HANDLE OneInstance( LPCTSTR lpName ) {
        HANDLE hMutex = CreateMutex(NULL, TRUE, lpName);
        switch(GetLastError()) {
                case ERROR_SUCCESS:
                        break;
                case ERROR_ALREADY_EXISTS:
                        hMutex = NULL;
                        MessageBox(0, "This program is already running!", "JavaRa 1.16", MB_OK | MB_ICONERROR);
                        break;
                default:
                        hMutex = NULL;
                        break;
        }
        return hMutex;
}

INT WINAPI WinMain( HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPSTR      lpCmdLine,
                    INT        nCmdShow )
{
    unsigned threadID; 
    HANDLE hMutex = OneInstance("JavaRa");
    if(!hMutex) {
                return FALSE;
    }
    
    TCHAR * commandList[] = { "-runsilent", "--runsilent", "--purgefiles", "-p", "-r", "--removeSDM", /* "--removeall" */ } ;
    if ( strcmp(lpCmdLine, "") != 0 ) {
         TCHAR * str = strtok(lpCmdLine, " "); 
         while ( str != NULL ) { 
            for ( int i = 0; i < 7; i++ ) {
                   if ( strcmp(commandList[i], str) == 0 ) {
                      switch(i) {
                                case 0: 
                                case 1:
                                case 4: {
                                     HANDLE hHandle = (HANDLE)_beginthreadex(NULL, 0, &Thread, NULL, 0, &threadID); 
                                     WaitForSingleObject(hHandle, INFINITE); 
                                     CloseHandle(hHandle); 
                                     // _beginthread(Thread, 0, NULL); 
                                     // Sleep(4000);
                                } 
                                break; 
                                case 2:
                                case 3: 
                                     purgeFiles(); 
                                break; 
                                case 5:
                                     removeSDM(); 
                                break; 
                                //case 6: 
//                                   HANDLE hHandle = (HANDLE)_beginthreadex(NULL, 0, &SecondThread, NULL, 0, &threadID); 
//                                   WaitForSingleObject(hHandle, INFINITE); 
//                                   CloseHandle(hHandle); 
//                                break; 
                     }
                  }
               } 
               str = strtok(NULL, " ");   
         }
         return 0;
    }
    hInst = hInstance;
    HWND hWnd = CreateDialog( hInstance, (LPCTSTR)"LANG_DIALOG", NULL, (DLGPROC)LangDlgProc );
    HMENU hMenu = GetSystemMenu(hWnd, FALSE);
    RemoveMenu(hMenu, SC_RESTORE, MF_BYCOMMAND);
    RemoveMenu(hMenu, SC_SIZE, MF_BYCOMMAND);
    RemoveMenu(hMenu, SC_MAXIMIZE, MF_BYCOMMAND);
    MSG    Msg;
    while(GetMessage(&Msg, NULL,0,0) == TRUE)
    {
        if(!IsDialogMessage(hWnd,&Msg))
        {
            TranslateMessage(&Msg);
            DispatchMessage(&Msg);
        }
    }
    return Msg.wParam;
}
